// Copyright (C) 1991 - 1999 Rational Software Corporation

#include "stdafx.h"
#include "GestionSite.h"

//##ModelId=3E900986009E
GestionSite::GestionSite()
{
	initGroupePortes();
	initGroupePersonnes();
	initAutorisations();
}

//##ModelId=3E900503002E
bool GestionSite::autorise(int badge, int porte)
{
	GroupePortes* gp = leGroupePortes(porte);
	return	find(
				gp->theGroupePersonnes.begin(), 
				gp->theGroupePersonnes.end(),
				leGroupePersonnes(badge)
			) != gp->theGroupePersonnes.end();
}

//##ModelId=3E9005460196
vector<Porte> GestionSite::listePorte(Personne personne)
{
	vector<Porte> lesPortes;
    return lesPortes;
}

//##ModelId=3E90846000CB
GroupePortes* GestionSite::leGroupePortes(int num)
{
	for (int i=0; i< theGroupePortes.size(); i++) {
		if ( find(
					theGroupePortes[i].thePortes.begin(), 
					theGroupePortes[i].thePortes.end(), 
					Porte(num)
			 ) != theGroupePortes[i].thePortes.end())
			return &theGroupePortes[i];
	}
	return (GroupePortes*)0;
}

//##ModelId=3E9084B50290
GroupePersonnes* GestionSite::leGroupePersonnes(int num)
{
	for (int i=0; i< theGroupePersonnes.size(); i++) {
		if ( find(
				theGroupePersonnes[i].thePersonnes.begin(), 
				theGroupePersonnes[i].thePersonnes.end(), 
				Personne("","",num)
			 ) != theGroupePersonnes[i].thePersonnes.end())
			return &theGroupePersonnes[i];
	}
	return (GroupePersonnes*)0;
}

//##ModelId=3E9009850232
GestionSite::~GestionSite()
{
}

//##ModelId=3E909FB1035B
void GestionSite::initGroupePortes()
{
	ifstream f1;
	vector<string> gpNom;

	f1.open(fGroupePortes.c_str()); 
	copy(
			istream_iterator<string>(f1), 
			istream_iterator<string>(), 
			back_inserter( gpNom )
		);
	f1.close();

	for (int i=0; i < gpNom.size(); i++) {
		string s = path + gpNom[i] + ".txt";
		GroupePortes gp ( gpNom[i] );
		f1.clear();
		f1.open( s.c_str() );
		copy(
				istream_iterator<int>(f1), 
				istream_iterator<int>(), 
				back_inserter( gp.thePortes )
			);
		f1.close();
		theGroupePortes.push_back (gp);
	}
}

//##ModelId=3E909FB1031C
void GestionSite::initGroupePersonnes()
{
	ifstream f1;
	vector<string> gpNom;

	f1.open(fGroupePersonnes.c_str()); 
	copy(
			istream_iterator<string>(f1), 
			istream_iterator<string>(), 
			back_inserter( gpNom )
		);
	f1.close();

	for (int i=0; i < gpNom.size(); i++) {
		string s = path + gpNom[i] + ".txt";
		GroupePersonnes gp ( gpNom[i] );
		f1.clear();
		f1.open( s.c_str() );
		copy(
				istream_iterator<string>(f1), 
				istream_iterator<string>(), 
				back_inserter( gp.thePersonnes )
			);
		f1.close();
		theGroupePersonnes.push_back (gp);
	}
}

//##ModelId=3E909FB103B9
pair<string,string> GestionSite::filtrer(string s)
{
	pair<string,string> p;

	int p1 = s.find ("|", 0);
	p.first = s.substr (0, p1);
	p1++;
	p.second = s.substr (p1, s.size() - p1);
	return p;
}

//##ModelId=3E909FB1038A
void GestionSite::initAutorisations()
{
	ifstream f1;
	vector<string> autorisations;
	pair<string,string> p;
	GroupePortes* gp;
	GroupePersonnes* gpr;

	f1.open(fAutorisations.c_str()); 
	copy(
			istream_iterator<string>(f1), 
			istream_iterator<string>(),									
			back_inserter( autorisations )
		);
	f1.close();

	for (int j=0; j < autorisations.size(); j++) {
		p = filtrer(autorisations[j]);
		gp = find(
					theGroupePortes.begin(), 
					theGroupePortes.end(), 
					GroupePortes(p.first)
				 );
		gpr = find(
					theGroupePersonnes.begin(), 
					theGroupePersonnes.end(), 
					GroupePersonnes(p.second)
				  );
		gp->theGroupePersonnes.push_back(gpr);
	}
}
